
#include <avr/io.h>
#include <util/delay.h>
#include "tlc5940.h"

// 24 Bytes for 16*12 Bit Values
uint8_t greyscale_values[24];

void init_tlc_con() {
	/*
	 * Initialize the ISP SEND PORTS
	 * PB7 = Attiny2313 UCSK
	 * PB5 = Attiny2313 MOSI
	 * PB4 = SS (Chip Select)
	 */
	DDRB = (1 << PB7) | (1 << PB5) | (1<<PB4);
	/*
	 * Enable the SPI Port,
	 * Set Master
	 * Set ClockRate
	 */
	SPCR = (1 << SPE) | (1 << MSTR) | (1 << SPR0);

}

void set_channel(uint8_t channel, uint8_t value) {
//TODO
}

void set_all_on(){
	for(int i = 0; i<24; i++){
		greyscale_values[i]= 0xFF;
	}
}

void set_all_off(){
	for(int i = 0; i<24; i++){
		greyscale_values[i] = 0x00;
	}
}

void send_to_device() {
	for (int i = 23; i >= 0; i--) {
		/*
		 * Sent Data from Array to TLC5940
		 */
		SPDR = greyscale_values[i];
		// wait until transmission complete
		while (!(SPSR & (1 << SPIF)))
			;
	}
}
